---
- name: Installs Apache, Mysql and configures users
  hosts: devops03
  become: true
  become_user: root
  vars_files:
    - vars/main.yml
  environment:
    MYSQL_LOCAL_INSTALLERS_PATH: /tmp
  tasks:
    - name: Cria usuário
      ansible.builtin.user:
        name: "{{ item.name }}"
        password: "{{ item.password | password_hash('sha512') }}"
        groups: "{{ item.groups }}"
        shell: "{{ item.shell }}"
        append: "{{ item.append }}"
        state: "{{ item.state }}"
      with_items: "{{ os_users }}"
    
    - name: Gera um par de chaves OpenSSH com os valores default (4096 bits, rsa)
      community.crypto.openssh_keypair:
        path: "/tmp/id_rsa"

    - name: Copia chaves geradas para user teste01
      ansible.builtin.copy:
        src: "/tmp/id_rsa"
        dest: "/home/teste01/.ssh/id_rsa"
        remote_src: true
        owner: "{{ item.name }}"
        group: "{{ item.name }}"
        mode: 0600
      with_items: "{{ os_users }}"

    - name: Copia chaves geradas para user teste01
      ansible.builtin.copy:
        src: "/tmp/id_rsa.pub"
        dest: "/home/teste01/.ssh/id_rsa.pub"
        remote_src: true
        owner: "{{ item.name }}"
        group: "{{ item.name }}"
        mode: 0600
      with_items: "{{ os_users }}"
    
    - name: Apaga chaves geradas
      ansible.builtin.file:
        path: "/tmp/id_rsa"
        state: absent
    
    - name: Apaga chaves geradas
      ansible.builtin.file:
        path: "/tmp/id_rsa.pub"
        state: absent

  roles:
    - installApache
    - role: mysql
      vars:
        mysql_authentication_plugin: mysql_native_password
        mysql_root_password: teste
        mysql_databases:
          - teste_db
        mysql_users:
          - { name: 'teste', host: 'localhost', password: 'teste' }
        mysql_user_access:
          - { name: 'teste', host: 'localhost', access: 'ALL', database: 'teste_db', tables: '*' }
        mysql_installers_path_list: /tmp
